package com.mortals.xhx.module.staff.dao.ibatis;


import com.mortals.framework.dao.ibatis.BaseCRUDDaoMybatis;
import com.mortals.framework.model.PageInfo;
import com.mortals.framework.model.ParamDto;
import com.mortals.framework.model.Result;
import com.mortals.xhx.module.staff.dao.StaffCareDao;
import com.mortals.xhx.module.staff.model.StaffCareEntity;
import org.apache.ibatis.session.RowBounds;
import org.springframework.stereotype.Repository;

import java.util.ArrayList;
import java.util.List;
/**
* 员工关怀信息DaoImpl DAO接口
*
* @author zxfei
* @date 2023-04-07
*/
@Repository("staffCareDao")
public class StaffCareDaoImpl extends BaseCRUDDaoMybatis<StaffCareEntity,Long> implements StaffCareDao {


    @Override
    public List<StaffCareEntity> getStaffCareList(StaffCareEntity query) {
        return this.getSqlSession().selectList(this.getSqlId("getStaffCareList"), query);
    }

    @Override
    public int getStaffCareListCount(StaffCareEntity query) {
        return (Integer)this.getSqlSession().selectOne(this.getSqlId("getStaffCareListCount"), query);
    }

    @Override
    public int initSendStatus() {
        return this.getSqlSession().update(this.getSqlId("initSendStatus"));
    }

    @Override
    public Result<StaffCareEntity> getList(StaffCareEntity params, PageInfo pageInfo) {

        Result result = new Result();
        List list = null;
        if (pageInfo.isCountPage()) {
            int count = this.getStaffCareListCount(params);
            if (count == 0) {
                list = new ArrayList();
            } else if (pageInfo.getPrePageResult() == -1) {
                list = this.getSqlSession().selectList(this.getSqlId("getStaffCareList"), params);
            } else {
                RowBounds rowBounds = new RowBounds(pageInfo.getBeginIndex(), pageInfo.getPrePageResult());
                list = this.getSqlSession().selectList(this.getSqlId("getStaffCareList"), params, rowBounds);
            }

            pageInfo.setTotalResult(count);
            result.setPageInfo(pageInfo);
            result.setList((List)list);
        } else {
            if (pageInfo.getPrePageResult() == -1) {
                list = this.getSqlSession().selectList(this.getSqlId("getStaffCareList"), params);
            } else {
                RowBounds rowBounds = new RowBounds(pageInfo.getBeginIndex(), pageInfo.getPrePageResult());
                list = this.getSqlSession().selectList(this.getSqlId("getStaffCareList"), params, rowBounds);
            }

            pageInfo.setTotalResult(-1);
            result.setPageInfo(pageInfo);
            result.setList(list);
        }

        return result;
    }
}
