package com.mortals.xhx.module.staff.model;
import java.util.Date;
import java.util.List;
import java.util.ArrayList;
import java.math.BigDecimal;
import cn.hutool.core.date.DateUtil;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.mortals.framework.annotation.Excel;
import com.mortals.framework.model.BaseEntityLong;
import com.mortals.xhx.module.staff.model.vo.StaffCareVo;
import lombok.Data;
/**
 * 员工关怀信息实体对象
 *
 * @author zxfei
 * @date 2025-04-15
 */
@Data
public class StaffCareEntity extends StaffCareVo {
    private static final long serialVersionUID = 1L;

    /**
     * 员工ID
     */
    private Long staffId;
    /**
     * 员工姓名
     */
    private String staffName;
    /**
     * 出生日期
     */
    private Date birthday;
    /**
     * 所属部门
     */
    private Long deptId;
    /**
     * 所属部门名称
     */
    private String deptName;
    /**
     * 职位ID
     */
    private Long jobId;
    /**
     * 职位名称
     */
    private String jobName;
    /**
     * 入职时间
     */
    private Date entryDate;
    /**
     * 关怀类型(1.生日关怀,2.入职周年关怀)
     */
    private Integer careType;
    /**
     * 发送状态(0.未发送,1.已发送)
     */
    private Integer sendStatus;
    /**
     * 关怀内容
     */
    private String content;
    /**
     * 执行时间
     */
    private Date excuteTime;
    /**
     * 员工类型（1.全职,2.兼职,3.实习)
     */
    private Integer staffType;
    @Override
    public int hashCode() {
        return this.getId().hashCode();
    }
    @Override
    public boolean equals(Object obj) {
        if (obj == null) return false;
        if (obj instanceof StaffCareEntity) {
            StaffCareEntity tmp = (StaffCareEntity) obj;
            if (this.getId() == tmp.getId()) {
                return true;
            }
        }
        return false;
    }

    public void initAttrValue(){
        this.staffId = null;
        this.staffName = "";
        this.birthday = null;
        this.deptId = null;
        this.deptName = "";
        this.jobId = null;
        this.jobName = "";
        this.entryDate = null;
        this.careType = 1;
        this.sendStatus = 0;
        this.content = "";
        this.excuteTime = null;
        this.staffType = 0;
    }
}